#include<stdio.h>
#include<stdlib.h>
#include<fstream.h>
#include<iostream>
#include<LEDA/window.h>
#include<LEDA/stream.h>
#include<LEDA/graph.h>
#include<LEDA/graphwin.h>
#include<LEDA/array.h>
#include<LEDA/node_array.h>


#define SIZE 500

using namespace leda;
using std::cout;
using std::cin;
using std::endl;

struct NODE{
  int vertex[SIZE];
  int exist;


  double dist;
};

void input(double A[SIZE][SIZE],int n,FILE *in); //ǡ
void copy(double A[SIZE][SIZE],double B[SIZE][SIZE],int n); //AB˥ԡ
void display(double A[SIZE][SIZE],int n); //ǡɽ
void diver(double A[SIZE][SIZE],double r[SIZE],struct NODE node[],int n);
void disp_1(double A[SIZE],int n);
void mat_dist(double A[SIZE][SIZE],double M[SIZE][SIZE],struct NODE node[],double r[SIZE],int n,int num);
void min_ij(double A[SIZE][SIZE],int n,int *x,int *y);
void bigsmall(int *big,int *small,int min_i,int min_j);
void list_data(struct NODE A[],int n);
void print_list(struct NODE A[],int n);
void branch(double A[SIZE][SIZE],double r[SIZE],struct NODE B[],int n,int min_i,int min_j,int big,int small,int k,FILE *out);
void make_G(int big,int small,int n,struct NODE B[],GRAPH <point,edge>& G,array <node> &v,array <edge> &e,node_array<int> &num,int cp[SIZE],node &origin,int *index);
double data(double A[SIZE][SIZE],int i,int j);
double distance(double A[SIZE][SIZE],int small,int big,int i);
void reconst(double d[SIZE][SIZE],double RE[SIZE][SIZE],struct NODE B[],int n,int small,int big);


//mainؿ
int main(int argc,char *argv[]){
  struct NODE node_data[SIZE];
  FILE *in,*out;
  double DATA[SIZE][SIZE];
  double M[SIZE][SIZE]; 
  double RENEW[SIZE][SIZE]; //Ƥǡ
  int n;
  int min_i,min_j;
  int small,big;
  double r[SIZE];
  int i;
  int index;
  string listname;

  in=fopen(argv[1],"r");
  out=fopen("A2_out.txt","w");
  

  if(!in){
    cout << "Input data!!" << endl;
    exit(1);
  }

  cout << "Input listname : " ;
  cin >>  listname;
 
  ifstream L_in(listname);
  fscanf(in,"%d",&n);


  /* ==========================================
               LEDA
  =============================================*/
  
  GRAPH<point,edge>G;
  GraphWin gw(G,"NJ");
  //gw1(G,argv[1]);
 
  //Graphwin
  gw.set_node_color(blue);
  //gw.set_node_label_type(user_label);
  gw.set_edge_direction(undirected_edge);
  //gw1.set_edge_direction(undirected_edge);
  gw.set_edge_color(pink);


  node origin=G.new_node(); //
 

  array<node>v(SIZE);    //nodev
  array<edge>e(SIZE);    //edgee

  //ǡդ
  for(i=0;i<=n-1;i++){
    v[i]=G.new_node();   
  }
  index=i;
  

  node_array<int> num(G);
  int cp[SIZE];
  

  for(i=0;i<=n-1;i++){
    cp[i]=i;
    cout <<"num " << cp[i] << " ";
  }
  num[origin]=100;
  
  /*
  node vertex;
  forall_nodes(vertex,G){
    gw.set_color(vertex,blue);
   
  }
  */
 
  //Υ()
  for(i=0;i<=n-1;i++){
    e[i]=G.new_edge(v[i],origin);
    //cout << v[i];
  }

  /*
  gw1.set_graph(G);
  point p(250,250);
  gw1.set_position(origin,p);
  double x0=250.0,y0=250.0,h=150.0,t;
  t=72.0*3.1415927/180.0;
  for(i=0;i<=n-1;i++){
    point pt(h*cos(t*i)+x0,h*sin(t*i)+y0);
    gw1.set_position(v[i],pt);
  }
  gw1.display();
  gw1.edit();
  */
  /*===========================================
            ޤ LEDA
  =============================================*/

 
  

  input(DATA,n,in); //ǡ
  copy(DATA,RENEW,n); //ǡcopy
  
  //Ϥ줿ǡɽ
  printf("============< input >===============\n");
  display(DATA,n); 
  printf("====================================\n");

  list_data(node_data,n); //node
  printf("-------set_data------\n");
  print_list(node_data,n); //nodeɽ
  printf("\n");
  
  for(i=0;i<n-2;i++){
    printf("===========================< start[%d] >=========================\n",i);
    printf("\n");
    printf("-------------< RENEW >-------------\n");
    display(RENEW,n); //ԡ줿ǡɽ
    printf("-----------------------------------\n");
    printf("\n");
    
    //diver(DATA,r,n);
    
    //r[i]ɽ
    diver(RENEW,r,node_data,n);
    disp_1(r,n);
    
    //mat_dist(DATA,M,r,n);
    
    //M[i][j]׻ɽ
    mat_dist(RENEW,M,node_data,r,n,i);
    display(M,n);

    //ǾͤȤʤmin_i,min_jɽ
    min_ij(M,n,&min_i,&min_j);
    bigsmall(&big,&small,min_i,min_j);
    printf("min_i=%d min_j=%d\n",min_i,min_j);
    printf("big=%d small=%d\n",big,small);
    //if(i==n-2) break;
    branch(RENEW,r,node_data,n,min_i,min_j,big,small,i,out);
    make_G(big,small,n,node_data,G,v,e,num,cp,origin,&index);
    print_list(node_data,n);
    reconst(DATA,RENEW,node_data,n,small,big);
    
   
    printf("===============================================================\n");
    printf("\n");
  }

  cout << G;

  cout <<"big=" << big << " " << "small=" << small << endl;
  
  
  G.del_node(origin);
  int E[SIZE];
  int j;
  for(i=0,j=0;i<=n-1;i++){
    if(node_data[i].exist==1){
      E[j]=i;
      j++;
    }
  }
  node v_end;
  node v_small,v_big;
  forall_nodes(v_end,G){
    if(num[v_end]==E[0]) v_small=v_end;
    else if(num[v_end]==E[1])   v_big=v_end;
  }
  G.new_edge(v_small,v_big);
  

  gw.set_graph(G);
  
  node s;
  forall_nodes(s,G){
    gw.set_width(s,10);
  }

  string st;
  for(i=0;i<=n-1;i++){
    if(L_in==NULL){
      st = 0x41+i;
    }else{
      L_in >> st;
    }
    gw.set_label(v[i],st);
    gw.set_shape(v[i],ellipse_node);
    gw.set_color(v[i],green);
    gw.set_height(v[i],15);
    gw.set_width(v[i],55);
  }

  /*
  for(i=0;i<=n-1;i++){
    gw.set_label(v[i],0x41+i);
    //point xy(h*cos(t*i)+x0,h*sin(t*i)+y0);
    //gw.set_position(v[i],xy);
    gw.set_color(v[i],blue);
  }
  */
  
  gw.display();
  gw.edit();

  //cout << G;
  
  
  fclose(in);
  fclose(out);
  return 0;

  
}

//ǡ
void input(double A[SIZE][SIZE],int n,FILE *in){
  int i,j;
  for(i=0;i<=n-1;i++){
    for(j=i+1;j<=n-1;j++){
      if(i>=j)
	A[i][j]=0;
      else
	fscanf(in,"%lf",&A[i][j]); 
    }
  }
}

//ɽ
void display(double A[SIZE][SIZE],int n){
  int i,j;
  for(i=0;i<=n-1;i++){
    
    for(j=0;j<=n-1;j++){
      printf(" %6.2f",A[i][j]);
    }
    printf("\n");
  }
}

//AB˥ԡ
void copy(double A[SIZE][SIZE],double B[SIZE][SIZE],int n){
  int i,j;
  for(i=0;i<=n-1;i++){
    for(j=0;j<=n-1;j++){
      B[i][j]=A[i][j];
    }
  } 
}

//nodeν
void list_data(struct NODE A[],int n){
  int i,j;

  for(i=0;i<=n-1;i++){
    for(j=0;j<=n-1;j++){
      
      if(j==0) A[i].vertex[0]=i+1;
      else A[i].vertex[j]=0;
      
    }
    A[i].exist=1;
    A[i].dist=0;
  }
  
}

//¤nodeΥǡɽ
void print_list(struct NODE A[],int n){
  int i,j;
   
  for(i=0;i<=n-1;i++){
    printf("node[%d].vertex:{",i);
    for(j=0;j<=n-1;j++){
      printf(" %d ",A[i].vertex[j]);
    }
    printf("}");
    printf("node[%d].exist:%d ",i,A[i].exist);
    printf("node[%d].dist:%6.2f ",i,A[i].dist);
    printf("\n");
  }
}


void disp_1(double A[SIZE],int n){
  int i;
  for(i=0;i<=n-1;i++){
    printf("r[%d]=%6.2f",i,A[i]);
  }
  printf("\n");
}

//net divergence
void diver(double A[SIZE][SIZE],double r[SIZE],struct NODE node[],int n){
  int i,j;
  
  //r[i]
  for(i=0;i<=n-1;i++){
    for(j=0;j<=n-1;j++){
      r[i]=0;
    }
  }
  
  for(i=0;i<=n-1;i++){
    
    if(node[i].exist==0) r[i]=0;
    else{
      for(j=0;j<=n-1;j++){
	if(node[j].exist==0) r[j]=0;
	else{
	  if(i<j)
	    r[i]+=A[i][j];
	  else if(i==j)
	    r[i]+=0;
	  else
	    r[i]+=A[j][i];
	}
      }
    }
  }
  
}

//Υ
void mat_dist(double A[SIZE][SIZE],double M[SIZE][SIZE],struct NODE node[],double r[SIZE],int n,int num){
  int i,j,g;


  for(i=0;i<=n-1;i++){
    for(j=i+1;j<=n-1;j++){
      if(node[j].exist==0||node[i].exist==0) M[i][j]=0;
      else{
	g=(int)(r[i]+r[j]);
	M[i][j]=A[i][j]-(double)g/(n-num-2);
      }
    }
  } 
}

//ǾȤʤڥi,j
void min_ij(double A[SIZE][SIZE],int n,int *x,int *y){
  int i,j;
  double min;
  
  min=1000;
  for(i=0;i<=n-1;i++){
    for(j=i+1;j<=n-1;j++){
      if(A[i][j]!=0 && min>A[i][j]){
	min=A[i][j];
	*x=i; *y=j;                     
      }
    }
  }
}


void bigsmall(int *big,int *small,int min_i,int min_j){
  if(min_i<=min_j){
    *small=min_i;
    *big=min_j;
  }else{
    *small=min_j;
    *big=min_i;
  }
}
  

//Ĺ
void branch(double A[SIZE][SIZE],double r[SIZE],struct NODE B[],int n,int min_i,int min_j,int big,int small,int k,FILE *out){
  double S[SIZE];
  int i,j,p;
  double q=2*((n-k)-2);
 
  p=(int)(r[min_i]-r[min_j]);
  S[min_i]=A[min_i][min_j]/2+(double)p/q;
  S[min_j]=A[min_i][min_j]-S[min_i];
  
  B[min_i].dist=S[min_i];
  B[min_j].dist=S[min_j];

  
  //ĹA2_out.txt˽
  fprintf(out,"Ĺɽ[%d]\n",i);
  fprintf(out,"[%d]distance:%6.2f\n",min_i,B[min_i].dist);
  fprintf(out,"[%d]distance:%6.2f\n",min_j,B[min_j].dist);

  
}

void make_G(int big,int small,int n,struct NODE B[],GRAPH <point,edge>& G,array <node> &v,array <edge> &e,node_array<int> &num,int cp[SIZE],node &origin,int *index){
  //GraphWin gw2(G);
  //gw2.set_node_color(blue);
  int i,j;

  v[*index]=G.new_node();
  num.init(G,100);
  cout << *index <<endl;

  for(i=0;i<=*index-1;i++){
    num[v[i]]=cp[i];  
    cout << "num[v[" << i << "]]=" << num[v[i]]<<endl;
    
  }

  num[v[*index]]=100;
  cout << "num[v["<<*index<<"]]="<<num[v[*index]]<<endl;
  
  
  node add_p;

  forall_nodes(add_p,G){
    
    if(small==num[add_p]){  
      cout << "num[add_p]=" << num[add_p]<< endl;
      
      G.del_edge(e[num[add_p]]);
      //G.del_edge(e[num[v[small]]]);
      G.new_edge(add_p,v[*index]);
      num[add_p]=100;
    }else if(big==num[add_p]){
      G.del_edge(e[num[add_p]]);
      //G.del_edge(e[num[v[big]]]);
      e[big]=G.new_edge(add_p,v[*index]);
    }
    
    
  }
  
  e[small]=G.new_edge(v[*index],origin);
  num[v[*index]]=small;
  num[v[small]]=100;
  
  
  cout <<"*index=" << *index << " num= "<<num[v[*index]] << endl;
  
  for(i=0;i<=*index;i++){
    cp[i]=num[v[i]];
    cout << "cp[" << i << "]=" << cp[i] << endl;
    
  }
  
    
  *index+=1;
  
    
  
  node pq;
  forall_nodes(pq,G){
    cout <<"num_i" << num[pq] <<endl;
  }
  
  B[big].exist=0;
  for(i=0;i<=n-1;i++){
    if(B[small].vertex[i]==0) break;
  }
  
  for(j=0;j<=n-1;j++){
    if(B[big].vertex[j]==0)
      break;
    else
      B[small].vertex[i+j]=B[big].vertex[j];
  }

  //gw2.set_graph(G);
  //gw2.display();
  //gw2.edit();
}

double data(double A[SIZE][SIZE],int i,int j){
  if(i<j)
    return A[i][j];
  else if(i>j)
    return A[j][i];
  else 
    return 0;
}

//Υ
double distance(double A[SIZE][SIZE],int small,int big,int i){
  double new_dist;
  new_dist=(data(A,small,i)+data(A,big,i)-data(A,small,big))/2;
  return new_dist;
}

//Υɽƹ 
void reconst(double d[SIZE][SIZE],double RE[SIZE][SIZE],struct NODE B[],int n,int small,int big){
  int i;
  RE[small][big]=0;
  for(i=0;i<=n-1;i++){
    if(B[i].exist==1 && i!=small){
      if(i<small){
	RE[i][small]=distance(d,small,big,i);
	RE[i][big]=0;
      }else{
	RE[small][i]=distance(d,small,big,i);
	RE[big][i]=0;
      }
    }
  }
}


